]> Savannah Git Hosting - gnulib.git/commitdiff
dzprintf-posix: Add tests.
authorBruno Haible <bruno@clisp.org>
Sun, 30 Jun 2024 15:25:46 +0000 (17:25 +0200)
committerBruno Haible <bruno@clisp.org>
Sun, 30 Jun 2024 15:25:56 +0000 (17:25 +0200)
* tests/test-dprintf-posix.h: New file, extracted from
tests/test-dprintf-posix.c.
* tests/test-dprintf-posix.c: Include it. Don't include infinity.h.
(test_function): Remove function.
* modules/dprintf-posix-tests (Files): Add it.
* tests/test-dzprintf-posix.c: New file, based on
tests/test-dprintf-posix.c.
* tests/test-dzprintf-posix.sh: New file, based on
tests/test-dprintf-posix.sh.
* modules/dzprintf-posix-tests: New file.

ChangeLog
modules/dprintf-posix-tests
modules/dzprintf-posix-tests [new file with mode: 0644]
tests/test-dprintf-posix.c
tests/test-dprintf-posix.h [new file with mode: 0644]
tests/test-dzprintf-posix.c [new file with mode: 0644]
tests/test-dzprintf-posix.sh [new file with mode: 0755]

index 4a915494fd5b8fe2592d0e5ef2d3341651d9384f..d4763ea449f42c1021b62e3e64fe5cf112f8550e 100644 (file)
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,5 +1,17 @@
 2024-06-30  Bruno Haible  <bruno@clisp.org>
 
+       dzprintf-posix: Add tests.
+       * tests/test-dprintf-posix.h: New file, extracted from
+       tests/test-dprintf-posix.c.
+       * tests/test-dprintf-posix.c: Include it. Don't include infinity.h.
+       (test_function): Remove function.
+       * modules/dprintf-posix-tests (Files): Add it.
+       * tests/test-dzprintf-posix.c: New file, based on
+       tests/test-dprintf-posix.c.
+       * tests/test-dzprintf-posix.sh: New file, based on
+       tests/test-dprintf-posix.sh.
+       * modules/dzprintf-posix-tests: New file.
+
        dzprintf-posix: New module.
        * modules/dzprintf-posix: New file.
 
index 09ebbc06f9b46fd6d51117b0c1072113d4e9b95e..a205742084db9de3ca8b24a4037e9b8003410c07 100644 (file)
@@ -1,6 +1,7 @@
 Files:
 tests/test-dprintf-posix.sh
 tests/test-dprintf-posix.c
+tests/test-dprintf-posix.h
 tests/test-printf-posix.output
 tests/test-dprintf-posix2.sh
 tests/test-dprintf-posix2.c
diff --git a/modules/dzprintf-posix-tests b/modules/dzprintf-posix-tests
new file mode 100644 (file)
index 0000000..c50df12
--- /dev/null
@@ -0,0 +1,16 @@
+Files:
+tests/test-dzprintf-posix.sh
+tests/test-dzprintf-posix.c
+tests/test-dprintf-posix.h
+tests/test-printf-posix.output
+tests/infinity.h
+tests/macros.h
+
+Depends-on:
+stdint
+
+configure.ac:
+
+Makefile.am:
+TESTS += test-dzprintf-posix.sh
+check_PROGRAMS += test-dzprintf-posix
index 4d952baa991c362390dea45e4f4fb2f2c99b99c6..122f3ecdc61e3d7f12b1c07fe77798cfc257ad74 100644 (file)
@@ -27,148 +27,10 @@ SIGNATURE_CHECK (dprintf, int, (int, const char *, ...));
 #include <stdint.h>
 #include <string.h>
 
-#include "infinity.h"
 #include "macros.h"
 
-static void
-test_function (int (*my_dprintf) (int, const char *, ...))
-{
-  /* Here we don't test output that may be platform dependent.
-     The bulk of the tests is done as part of the 'vasnprintf-posix' module.  */
-
-  /* Test support of size specifiers as in C99.  */
-
-  my_dprintf (fileno (stdout), "%ju %d\n", (uintmax_t) 12345671, 33, 44, 55);
-
-  my_dprintf (fileno (stdout), "%zu %d\n", (size_t) 12345672, 33, 44, 55);
-
-  my_dprintf (fileno (stdout), "%tu %d\n", (ptrdiff_t) 12345673, 33, 44, 55);
-
-  /* Test the support of the 'a' and 'A' conversion specifier for hexadecimal
-     output of floating-point numbers.  */
-
-  /* Positive zero.  */
-  my_dprintf (fileno (stdout), "%a %d\n", 0.0, 33, 44, 55);
-
-  /* Positive infinity.  */
-  my_dprintf (fileno (stdout), "%a %d\n", Infinityd (), 33, 44, 55);
-
-  /* Negative infinity.  */
-  my_dprintf (fileno (stdout), "%a %d\n", - Infinityd (), 33, 44, 55);
-
-  /* FLAG_ZERO with infinite number.  */
-  my_dprintf (fileno (stdout), "%010a %d\n", Infinityd (), 33, 44, 55);
-
-  /* Test the support of the %f format directive.  */
-
-  /* A positive number.  */
-  my_dprintf (fileno (stdout), "%f %d\n", 12.75, 33, 44, 55);
-
-  /* A larger positive number.  */
-  my_dprintf (fileno (stdout), "%f %d\n", 1234567.0, 33, 44, 55);
-
-  /* A negative number.  */
-  my_dprintf (fileno (stdout), "%f %d\n", -0.03125, 33, 44, 55);
-
-  /* Positive zero.  */
-  my_dprintf (fileno (stdout), "%f %d\n", 0.0, 33, 44, 55);
-
-  /* FLAG_ZERO.  */
-  my_dprintf (fileno (stdout), "%015f %d\n", 1234.0, 33, 44, 55);
-
-  /* Precision.  */
-  my_dprintf (fileno (stdout), "%.f %d\n", 1234.0, 33, 44, 55);
-
-  /* Precision with no rounding.  */
-  my_dprintf (fileno (stdout), "%.2f %d\n", 999.95, 33, 44, 55);
-
-  /* Precision with rounding.  */
-  my_dprintf (fileno (stdout), "%.2f %d\n", 999.996, 33, 44, 55);
-
-  /* A positive number.  */
-  my_dprintf (fileno (stdout), "%Lf %d\n", 12.75L, 33, 44, 55);
-
-  /* A larger positive number.  */
-  my_dprintf (fileno (stdout), "%Lf %d\n", 1234567.0L, 33, 44, 55);
-
-  /* A negative number.  */
-  my_dprintf (fileno (stdout), "%Lf %d\n", -0.03125L, 33, 44, 55);
-
-  /* Positive zero.  */
-  my_dprintf (fileno (stdout), "%Lf %d\n", 0.0L, 33, 44, 55);
-
-  /* FLAG_ZERO.  */
-  my_dprintf (fileno (stdout), "%015Lf %d\n", 1234.0L, 33, 44, 55);
-
-  /* Precision.  */
-  my_dprintf (fileno (stdout), "%.Lf %d\n", 1234.0L, 33, 44, 55);
-
-  /* Precision with no rounding.  */
-  my_dprintf (fileno (stdout), "%.2Lf %d\n", 999.95L, 33, 44, 55);
-
-  /* Precision with rounding.  */
-  my_dprintf (fileno (stdout), "%.2Lf %d\n", 999.996L, 33, 44, 55);
-
-  /* Test the support of the %F format directive.  */
-
-  /* A positive number.  */
-  my_dprintf (fileno (stdout), "%F %d\n", 12.75, 33, 44, 55);
-
-  /* A larger positive number.  */
-  my_dprintf (fileno (stdout), "%F %d\n", 1234567.0, 33, 44, 55);
-
-  /* A negative number.  */
-  my_dprintf (fileno (stdout), "%F %d\n", -0.03125, 33, 44, 55);
-
-  /* Positive zero.  */
-  my_dprintf (fileno (stdout), "%F %d\n", 0.0, 33, 44, 55);
-
-  /* FLAG_ZERO.  */
-  my_dprintf (fileno (stdout), "%015F %d\n", 1234.0, 33, 44, 55);
-
-  /* Precision.  */
-  my_dprintf (fileno (stdout), "%.F %d\n", 1234.0, 33, 44, 55);
-
-  /* Precision with no rounding.  */
-  my_dprintf (fileno (stdout), "%.2F %d\n", 999.95, 33, 44, 55);
-
-  /* Precision with rounding.  */
-  my_dprintf (fileno (stdout), "%.2F %d\n", 999.996, 33, 44, 55);
-
-  /* A positive number.  */
-  my_dprintf (fileno (stdout), "%LF %d\n", 12.75L, 33, 44, 55);
-
-  /* A larger positive number.  */
-  my_dprintf (fileno (stdout), "%LF %d\n", 1234567.0L, 33, 44, 55);
-
-  /* A negative number.  */
-  my_dprintf (fileno (stdout), "%LF %d\n", -0.03125L, 33, 44, 55);
-
-  /* Positive zero.  */
-  my_dprintf (fileno (stdout), "%LF %d\n", 0.0L, 33, 44, 55);
-
-  /* FLAG_ZERO.  */
-  my_dprintf (fileno (stdout), "%015LF %d\n", 1234.0L, 33, 44, 55);
-
-  /* Precision.  */
-  my_dprintf (fileno (stdout), "%.LF %d\n", 1234.0L, 33, 44, 55);
-
-  /* Precision with no rounding.  */
-  my_dprintf (fileno (stdout), "%.2LF %d\n", 999.95L, 33, 44, 55);
-
-  /* Precision with rounding.  */
-  my_dprintf (fileno (stdout), "%.2LF %d\n", 999.996L, 33, 44, 55);
-
-  /* Test the support of the %b format directive.  */
-
-  /* This test would fail on glibc 2.34, musl libc, macOS 14,
-     FreeBSD 13.2, NetBSD 10.0, OpenBSD 7.5, AIX 7.3, Solaris 11.4.  */
-  my_dprintf (fileno (stdout), "%b %d\n", 12345, 33, 44, 55);
-
-  /* Test the support of the POSIX/XSI format strings with positions.  */
-
-  my_dprintf (fileno (stdout), "%2$d %1$d\n", 33, 55);
-}
+#define RETTYPE int
+#include "test-dprintf-posix.h"
 
 int
 main (int argc, char *argv[])
diff --git a/tests/test-dprintf-posix.h b/tests/test-dprintf-posix.h
new file mode 100644 (file)
index 0000000..97d763f
--- /dev/null
@@ -0,0 +1,159 @@
+/* Test of d[z]printf() with POSIX compatible format string interpretation.
+   Copyright (C) 2007-2024 Free Software Foundation, Inc.
+
+   This program is free software: you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation, either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */
+
+/* Written by Bruno Haible <bruno@clisp.org>, 2009.  */
+
+#include "infinity.h"
+
+static void
+test_function (RETTYPE (*my_dprintf) (int, const char *, ...))
+{
+  /* Here we don't test output that may be platform dependent.
+     The bulk of the tests is done as part of the 'vasnprintf-posix' module.  */
+
+  /* Test support of size specifiers as in C99.  */
+
+  my_dprintf (fileno (stdout), "%ju %d\n", (uintmax_t) 12345671, 33, 44, 55);
+
+  my_dprintf (fileno (stdout), "%zu %d\n", (size_t) 12345672, 33, 44, 55);
+
+  my_dprintf (fileno (stdout), "%tu %d\n", (ptrdiff_t) 12345673, 33, 44, 55);
+
+  /* Test the support of the 'a' and 'A' conversion specifier for hexadecimal
+     output of floating-point numbers.  */
+
+  /* Positive zero.  */
+  my_dprintf (fileno (stdout), "%a %d\n", 0.0, 33, 44, 55);
+
+  /* Positive infinity.  */
+  my_dprintf (fileno (stdout), "%a %d\n", Infinityd (), 33, 44, 55);
+
+  /* Negative infinity.  */
+  my_dprintf (fileno (stdout), "%a %d\n", - Infinityd (), 33, 44, 55);
+
+  /* FLAG_ZERO with infinite number.  */
+  my_dprintf (fileno (stdout), "%010a %d\n", Infinityd (), 33, 44, 55);
+
+  /* Test the support of the %f format directive.  */
+
+  /* A positive number.  */
+  my_dprintf (fileno (stdout), "%f %d\n", 12.75, 33, 44, 55);
+
+  /* A larger positive number.  */
+  my_dprintf (fileno (stdout), "%f %d\n", 1234567.0, 33, 44, 55);
+
+  /* A negative number.  */
+  my_dprintf (fileno (stdout), "%f %d\n", -0.03125, 33, 44, 55);
+
+  /* Positive zero.  */
+  my_dprintf (fileno (stdout), "%f %d\n", 0.0, 33, 44, 55);
+
+  /* FLAG_ZERO.  */
+  my_dprintf (fileno (stdout), "%015f %d\n", 1234.0, 33, 44, 55);
+
+  /* Precision.  */
+  my_dprintf (fileno (stdout), "%.f %d\n", 1234.0, 33, 44, 55);
+
+  /* Precision with no rounding.  */
+  my_dprintf (fileno (stdout), "%.2f %d\n", 999.95, 33, 44, 55);
+
+  /* Precision with rounding.  */
+  my_dprintf (fileno (stdout), "%.2f %d\n", 999.996, 33, 44, 55);
+
+  /* A positive number.  */
+  my_dprintf (fileno (stdout), "%Lf %d\n", 12.75L, 33, 44, 55);
+
+  /* A larger positive number.  */
+  my_dprintf (fileno (stdout), "%Lf %d\n", 1234567.0L, 33, 44, 55);
+
+  /* A negative number.  */
+  my_dprintf (fileno (stdout), "%Lf %d\n", -0.03125L, 33, 44, 55);
+
+  /* Positive zero.  */
+  my_dprintf (fileno (stdout), "%Lf %d\n", 0.0L, 33, 44, 55);
+
+  /* FLAG_ZERO.  */
+  my_dprintf (fileno (stdout), "%015Lf %d\n", 1234.0L, 33, 44, 55);
+
+  /* Precision.  */
+  my_dprintf (fileno (stdout), "%.Lf %d\n", 1234.0L, 33, 44, 55);
+
+  /* Precision with no rounding.  */
+  my_dprintf (fileno (stdout), "%.2Lf %d\n", 999.95L, 33, 44, 55);
+
+  /* Precision with rounding.  */
+  my_dprintf (fileno (stdout), "%.2Lf %d\n", 999.996L, 33, 44, 55);
+
+  /* Test the support of the %F format directive.  */
+
+  /* A positive number.  */
+  my_dprintf (fileno (stdout), "%F %d\n", 12.75, 33, 44, 55);
+
+  /* A larger positive number.  */
+  my_dprintf (fileno (stdout), "%F %d\n", 1234567.0, 33, 44, 55);
+
+  /* A negative number.  */
+  my_dprintf (fileno (stdout), "%F %d\n", -0.03125, 33, 44, 55);
+
+  /* Positive zero.  */
+  my_dprintf (fileno (stdout), "%F %d\n", 0.0, 33, 44, 55);
+
+  /* FLAG_ZERO.  */
+  my_dprintf (fileno (stdout), "%015F %d\n", 1234.0, 33, 44, 55);
+
+  /* Precision.  */
+  my_dprintf (fileno (stdout), "%.F %d\n", 1234.0, 33, 44, 55);
+
+  /* Precision with no rounding.  */
+  my_dprintf (fileno (stdout), "%.2F %d\n", 999.95, 33, 44, 55);
+
+  /* Precision with rounding.  */
+  my_dprintf (fileno (stdout), "%.2F %d\n", 999.996, 33, 44, 55);
+
+  /* A positive number.  */
+  my_dprintf (fileno (stdout), "%LF %d\n", 12.75L, 33, 44, 55);
+
+  /* A larger positive number.  */
+  my_dprintf (fileno (stdout), "%LF %d\n", 1234567.0L, 33, 44, 55);
+
+  /* A negative number.  */
+  my_dprintf (fileno (stdout), "%LF %d\n", -0.03125L, 33, 44, 55);
+
+  /* Positive zero.  */
+  my_dprintf (fileno (stdout), "%LF %d\n", 0.0L, 33, 44, 55);
+
+  /* FLAG_ZERO.  */
+  my_dprintf (fileno (stdout), "%015LF %d\n", 1234.0L, 33, 44, 55);
+
+  /* Precision.  */
+  my_dprintf (fileno (stdout), "%.LF %d\n", 1234.0L, 33, 44, 55);
+
+  /* Precision with no rounding.  */
+  my_dprintf (fileno (stdout), "%.2LF %d\n", 999.95L, 33, 44, 55);
+
+  /* Precision with rounding.  */
+  my_dprintf (fileno (stdout), "%.2LF %d\n", 999.996L, 33, 44, 55);
+
+  /* Test the support of the %b format directive.  */
+
+  /* This test would fail on glibc 2.34, musl libc, macOS 14,
+     FreeBSD 13.2, NetBSD 10.0, OpenBSD 7.5, AIX 7.3, Solaris 11.4.  */
+  my_dprintf (fileno (stdout), "%b %d\n", 12345, 33, 44, 55);
+
+  /* Test the support of the POSIX/XSI format strings with positions.  */
+
+  my_dprintf (fileno (stdout), "%2$d %1$d\n", 33, 55);
+}
diff --git a/tests/test-dzprintf-posix.c b/tests/test-dzprintf-posix.c
new file mode 100644 (file)
index 0000000..736645f
--- /dev/null
@@ -0,0 +1,37 @@
+/* Test of dzprintf() with POSIX compatible format string interpretation.
+   Copyright (C) 2007-2024 Free Software Foundation, Inc.
+
+   This program is free software: you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation, either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */
+
+/* Written by Bruno Haible <bruno@clisp.org>, 2009.  */
+
+#include <config.h>
+
+#include <stdio.h>
+
+#include <stddef.h>
+#include <stdint.h>
+#include <string.h>
+
+#include "macros.h"
+
+#define RETTYPE off64_t
+#include "test-dprintf-posix.h"
+
+int
+main (int argc, char *argv[])
+{
+  test_function (dzprintf);
+  return test_exit_status;
+}
diff --git a/tests/test-dzprintf-posix.sh b/tests/test-dzprintf-posix.sh
new file mode 100755 (executable)
index 0000000..e432586
--- /dev/null
@@ -0,0 +1,16 @@
+#!/bin/sh
+
+tmpfiles=""
+trap 'rm -fr $tmpfiles' HUP INT QUIT TERM
+
+tmpfiles="$tmpfiles t-dzprintf-posix.tmp t-dzprintf-posix.out"
+${CHECKER} ./test-dzprintf-posix${EXEEXT} > t-dzprintf-posix.tmp || exit 1
+LC_ALL=C tr -d '\r' < t-dzprintf-posix.tmp > t-dzprintf-posix.out || exit 1
+
+: "${DIFF=diff}"
+${DIFF} "${srcdir}/test-printf-posix.output" t-dzprintf-posix.out
+result=$?
+
+rm -fr $tmpfiles
+
+exit $result